'From Cuis 5.0 [latest update: #4576] on 29 April 2021 at 10:01:44 am'!
!classDefinition: #ProcessTerminateBug category: 'BaseImageTests-Kernel-Processes'!
TestCase subclass: #ProcessTerminateBug
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BaseImageTests-Kernel-Processes'!
!classDefinition: #ProcessorTest category: 'BaseImageTests-Kernel-Processes'!
TestCase subclass: #ProcessorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BaseImageTests-Kernel-Processes'!

!ProcessTerminateBug methodsFor: 'tests' stamp: 'jmv 4/28/2021 16:39:49'!
testResumptionDuringNestedUnwind1
	"Resume suspended process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p x1 x2 x3 x4 |
	x1 := x2 := x3 := x4 := false.
	p := 
		[
			[
				[ ] ensure: [
					[Processor activeProcess suspend] ensure: [
						x1 := true]. 
					x2 := true]
			] ensure: [
				x3 := true].
			x4 := true.
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is suspended and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	self deny: x1 | x2 | x3 | x4.
	"now resume the process and make sure all unwind blocks have finished"
	p resume.
	Processor yield.
	self assert: p isTerminated.
	self assert: x1 & x2 & x3 & x4.! !

!ProcessTerminateBug methodsFor: 'tests' stamp: 'jmv 4/28/2021 16:40:02'!
testResumptionDuringNestedUnwind2
	"Resume suspended process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p x1 x2 x3 x4 |
	x1 := x2 := x3 := x4 := false.
	p := 
		[
			[
				[ ] ensure: [
					[ ] ensure: [
						Processor activeProcess suspend. 
						x1 := true]. 
					x2 := true]
			] ensure: [
				x3 := true].
			x4 := true.
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is suspended and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	self deny: x1 | x2 | x3 | x4.
	"now resume the process and make sure all unwind blocks have finished"
	p resume.
	Processor yield.
	self assert: p isTerminated.
	self assert: x1 & x2 & x3 & x4.! !

!ProcessTerminateBug methodsFor: 'tests' stamp: 'jmv 4/28/2021 16:40:14'!
testResumptionDuringNestedUnwind3
	"Resume runnable process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p x1 x2 x3 x4 |
	x1 := x2 := x3 := x4 := false.
	p := 
		[
			[
				[ ] ensure: [
					[Processor yield] ensure: [
						x1 := true]. 
					x2 := true]
			] ensure: [
				x3 := true].
			x4 := true.
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is runnable and none of the unwind blocks has finished yet"
	self assert: p isReady.
	self deny: x1 | x2 | x3 | x4.
	"now resume the process and make sure all unwind blocks have finished"
	p resume.
	Processor yield.
	self assert: p isTerminated.
	self assert: x1 & x2 & x3 & x4.! !

!ProcessTerminateBug methodsFor: 'tests' stamp: 'jmv 4/28/2021 16:40:26'!
testResumptionDuringNestedUnwind4
	"Resume runnable process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p x1 x2 x3 x4 |
	x1 := x2 := x3 := x4 := false.
	p := 
		[
			[
				[ ] ensure: [
					[ ] ensure: [
						Processor yield. 
						x1 := true]. 
					x2 := true]
			] ensure: [
				x3 := true].
			x4 := true.
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is suspended and none of the unwind blocks has finished yet"
	self assert: p isReady.
	self deny: x1 | x2 | x3 | x4.
	"now resume the process and make sure all unwind blocks have finished"
	p resume.
	Processor yield.
	self assert: p isTerminated.
	self assert: x1 & x2 & x3 & x4.! !

!ProcessTerminateBug methodsFor: 'tests' stamp: 'jmv 4/28/2021 16:40:40'!
testResumptionDuringNestedUnwind7
	"Resume blocked process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p x1 x2 x3 x4 semaphore |
	x1 := x2 := x3 := x4 := false.
	semaphore := Semaphore new.
	p := 
		[
			[
				[ ] ensure: [
					[semaphore wait] ensure: [
						x1 := true]. 
					x2 := true]
			] ensure: [
				x3 := true].
			x4 := true.
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is runnable and none of the unwind blocks has finished yet"
	self assert: p isBlocked.
	self deny: x1 | x2 | x3 | x4.
	"now resume the process and make sure all unwind blocks have finished"
	semaphore signal.
	Processor yield.
	self assert: p isTerminated.
	self assert: x1 & x2 & x3 & x4.! !

!ProcessTerminateBug methodsFor: 'tests' stamp: 'jmv 4/28/2021 16:40:50'!
testResumptionDuringNestedUnwind8
	"Resume blocked process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p x1 x2 x3 x4 semaphore |
	x1 := x2 := x3 := x4 := false.
	semaphore := Semaphore new.
	p := 
		[
			[
				[ ] ensure: [
					[ ] ensure: [
						semaphore wait.
						x1 := true]. 
					x2 := true]
			] ensure: [
				x3 := true].
			x4 := true.
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is runnable and none of the unwind blocks has finished yet"
	self assert: p isBlocked.
	self deny: x1 | x2 | x3 | x4.
	"now resume the process and make sure all unwind blocks have finished"
	semaphore signal.
	Processor yield.
	self assert: p isTerminated.
	self assert: x1 & x2 & x3 & x4.! !

!ProcessTerminateBug methodsFor: 'tests' stamp: 'jmv 4/28/2021 16:12:51'!
testTerminationDuringNestedUnwind1
	"Terminate suspended process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p x1 x2 x3 x4 |
	x1 := x2 := x3 := x4 := false.
	p := 
		[
			[
				[ ] ensure: [
					[Processor activeProcess suspend] ensure: [
						x1 := true]. 
					x2 := true]
			] ensure: [
				x3 := true].
			x4 := true.
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is suspended and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	self deny: x1 | x2 | x3 | x4.
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: x1 & x2 & x3.
	self deny: x4.! !

!ProcessTerminateBug methodsFor: 'tests' stamp: 'jmv 4/28/2021 16:12:59'!
testTerminationDuringNestedUnwind2
	"Terminate suspended process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p x1 x2 x3 x4 |
	x1 := x2 := x3 := x4 := false.
	p := 
		[
			[
				[ ] ensure: [
					[ ] ensure: [
						Processor activeProcess suspend. 
						x1 := true]. 
					x2 := true]
			] ensure: [
				x3 := true].
			x4 := true.
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is suspended and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	self deny: x1 | x2 | x3 | x4.
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: x1 & x2 & x3.
	self deny: x4.! !

!ProcessTerminateBug methodsFor: 'tests' stamp: 'jmv 4/28/2021 16:33:24'!
testTerminationDuringNestedUnwind3
	"Terminate runnable process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p x1 x2 x3 x4 |
	x1 := x2 := x3 := x4 := false.
	p := 
		[
			[
				[ ] ensure: [
					[Processor yield] ensure: [
						x1 := true]. 
					x2 := true]
			] ensure: [
				x3 := true].
			x4 := true.
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is runnable and none of the unwind blocks has finished yet"
	self assert: p isReady.
	self deny: x1 | x2 | x3 | x4.
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: x1 & x2 & x3.
	self deny: x4.! !

!ProcessTerminateBug methodsFor: 'tests' stamp: 'jmv 4/28/2021 16:33:38'!
testTerminationDuringNestedUnwind4
	"Terminate runnable process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p x1 x2 x3 x4 |
	x1 := x2 := x3 := x4 := false.
	p := 
		[
			[
				[ ] ensure: [
					[ ] ensure: [
						Processor yield. 
						x1 := true]. 
					x2 := true]
			] ensure: [
				x3 := true].
			x4 := true.
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is suspended and none of the unwind blocks has finished yet"
	self assert: p isReady.
	self deny: x1 | x2 | x3 | x4.
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: x1 & x2 & x3.
	self deny: x4.! !

!ProcessTerminateBug methodsFor: 'tests' stamp: 'jmv 4/28/2021 16:33:42'!
testTerminationDuringNestedUnwind5
	"Terminate active process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p x1 x2 x3 x4 |
	x1 := x2 := x3 := x4 := false.
	p := 
		[
			[
				[ ] ensure: [
					[Processor activeProcess terminate] ensure: [
						x1 := true]. 
					x2 := true]
			] ensure: [
				x3 := true].
			x4 := true.
		] newProcess.
	p resume.
	Processor yield.
	"make sure p suspended itself and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	self deny: x1 | x2 | x3 | x4.
	"now let the termination continue and make sure all unwind blocks have finished"
	Processor yield.
	self assert: p isTerminated.
	self assert: x1 & x2 & x3.
	self deny: x4.! !

!ProcessTerminateBug methodsFor: 'tests' stamp: 'jmv 4/28/2021 16:33:47'!
testTerminationDuringNestedUnwind6
	"Terminate active process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p x1 x2 x3 x4 |
	x1 := x2 := x3 := x4 := false.
	p := 
		[
			[
				[ ] ensure: [
					[ ] ensure: [
						Processor activeProcess terminate.
						x1 := true]. 
					x2 := true]
			] ensure: [
				x3 := true].
			x4 := true.
		] newProcess.
	p resume.
	Processor yield.
	"make sure p suspended itself and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	self deny: x1 | x2 | x3 | x4.
	"now let the termination continue and make sure all unwind blocks have finished"
	Processor yield.
	self assert: p isTerminated.
	self assert: x1 & x2 & x3.
	self deny: x4.! !

!ProcessTerminateBug methodsFor: 'tests' stamp: 'jmv 4/28/2021 16:33:52'!
testTerminationDuringNestedUnwind7
	"Terminate blocked process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p x1 x2 x3 x4 semaphore |
	x1 := x2 := x3 := x4 := false.
	semaphore := Semaphore new.
	p := 
		[
			[
				[ ] ensure: [
					[semaphore wait] ensure: [
						x1 := true]. 
					x2 := true]
			] ensure: [
				x3 := true].
			x4 := true.
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is runnable and none of the unwind blocks has finished yet"
	self assert: p isBlocked.
	self deny: x1 | x2 | x3 | x4.
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: x1 & x2 & x3.
	self deny: x4.! !

!ProcessTerminateBug methodsFor: 'tests' stamp: 'jmv 4/28/2021 16:33:56'!
testTerminationDuringNestedUnwind8
	"Terminate blocked process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p x1 x2 x3 x4 semaphore |
	x1 := x2 := x3 := x4 := false.
	semaphore := Semaphore new.
	p := 
		[
			[
				[ ] ensure: [
					[ ] ensure: [
						semaphore wait.
						x1 := true]. 
					x2 := true]
			] ensure: [
				x3 := true].
			x4 := true.
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is runnable and none of the unwind blocks has finished yet"
	self assert: p isBlocked.
	self deny: x1 | x2 | x3 | x4.
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: x1 & x2 & x3.
	self deny: x4.! !


!ProcessTest methodsFor: 'tests' stamp: 'jmv 4/13/2021 14:03:54'!
testTerminateInEnsure
	"As shown in
	Martin McClure's 'Threads, Critical Sections, and Termination' (Smalltalks 2019 conference)
	https://youtu.be/AvM5YrjK9AE
	at 23:17
	self new testTerminateInEnsure
	"
	| process count random delay |
	random _ Random new.
	10 timesRepeat: [
		process _ [
			count _ 0.
			[] ensure: [
				10 timesRepeat: [
					count _ count + 1.
					1000000 timesRepeat: [12 factorial]].
				count _ count + 1]
			] newProcess.
		process resumeAt: Processor activeProcess priority - 1.
		delay _ (random next * 100) asInteger + 10. 									"avoid 0-ms delay"
		(Delay forMilliseconds: delay) wait.
		self assert: process isTerminated not.
		process terminate.
		process priority: Processor activeProcess priority + 1.
		self
			assert: process isTerminated;
			assert: count equals: 11 ]! !

!ProcessTest methodsFor: 'tests' stamp: 'jmv 4/13/2021 14:13:35'!
testValueEnsured
	"Based on #testTerminateInEnsure
	Tweaked to raise likelihood of failure, besides testing #valueEnsured
	self new testValueEnsured
	"
	| process count random delay |
	random _ Random new.
	100 timesRepeat: [
		process _ [
			count _ 0.
			[
				10 timesRepeat: [
					count _ count + 1.
					100000 timesRepeat: [12 factorial]].
				count _ count + 1 ] valueEnsured
			] newProcess.
		process resumeAt: Processor activeProcess priority - 1.
		delay _ (random next * 10) asInteger + 10. 									"avoid 0-ms delay"
		(Delay forMilliseconds: delay) wait.
		self assert: process isTerminated not.
		process terminate.
		process priority: Processor activeProcess priority + 1.
		self
			assert: process isTerminated;
			assert: count equals: 11 ]! !

