'From Cuis 5.0 [latest update: #4578] on 29 April 2021 at 3:01:16 pm'!
!classDefinition: #ProcessTerminateUnwindNonLocalReturn category: 'BaseImageTests-Kernel-Processes'!
TestCase subclass: #ProcessTerminateUnwindNonLocalReturn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BaseImageTests-Kernel-Processes'!

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:51:32'!
test1AResume
	"Resume suspended process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux1A: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is suspended and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now resume the process and make sure all unwind blocks have finished"
	p resume.
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a third & a fourth.
	self deny: a second.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:07:16'!
test1ATerminate
	"Terminate suspended process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux1A: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is suspended and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a third.
	self deny: a second | a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 12:54:13'!
test1BResume
	"Resume suspended process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux1B: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is suspended and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now resume the process and make sure all unwind blocks have finished"
	p resume.
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a second & a third & a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:07:21'!
test1BTerminate
	"Terminate suspended process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux1B: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is suspended and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 13:15:46'!
test1CResume
	"Resume suspended process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux1C: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is suspended and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now resume the process and make sure all unwind blocks have finished"
	p resume.
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:07:26'!
test1CTerminate
	"Terminate suspended process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux1C: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is suspended and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 10:40:29'!
test1DResume
	"Resume suspended process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux1D: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is suspended and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now resume the process and make sure all unwind blocks have finished"
	p resume.
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a second & a third & a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:07:29'!
test1DTerminate
	"Terminate suspended process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux1D: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is suspended and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 12:57:20'!
test2AResume
	"Resume suspended process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux2A: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is suspended and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now resume the process and make sure all unwind blocks have finished"
	p resume.
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a third & a fourth.
	self deny: a second.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:07:33'!
test2ATerminate
	"Terminate suspended process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux2A: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is suspended and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a third.
	self deny: a second | a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 12:57:35'!
test2BResume
	"Resume suspended process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux2B: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is suspended and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now resume the process and make sure all unwind blocks have finished"
	p resume.
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a second & a third & a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:07:42'!
test2BTerminate
	"Terminate suspended process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux2B: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is suspended and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 13:15:51'!
test2CResume
	"Resume suspended process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux2C: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is suspended and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now resume the process and make sure all unwind blocks have finished"
	p resume.
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:07:48'!
test2CTerminate
	"Terminate suspended process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux2C: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is suspended and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 10:46:06'!
test2DResume
	"Resume suspended process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux2D: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is suspended and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now resume the process and make sure all unwind blocks have finished"
	p resume.
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a second & a third & a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:07:52'!
test2DTerminate
	"Terminate suspended process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux2D: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is suspended and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 13:10:14'!
test3AResume
	"Resume runnable process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux3A: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is runnable and none of the unwind blocks has finished yet"
	self assert: p isReady.
	a noneSatisfy: [ :b | b ].
	"now let the process run and make sure all unwind blocks have finished"
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a third & a fourth.
	self deny: a second.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:19:39'!
test3ATerminate
	"Terminate runnable process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux3A: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is runnable and none of the unwind blocks has finished yet"
	self assert: p isReady.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a third.
	self deny: a second | a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 13:11:50'!
test3BResume
	"Resume runnable process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux3B: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is runnable and none of the unwind blocks has finished yet"
	self assert: p isReady.
	a noneSatisfy: [ :b | b ].
	"now let the process run and make sure all unwind blocks have finished"
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a second & a third & a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:20:50'!
test3BTerminate
	"Terminate runnable process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux3B: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is runnable and none of the unwind blocks has finished yet"
	self assert: p isReady.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 13:15:55'!
test3CResume
	"Resume runnable process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux3C: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is runnable and none of the unwind blocks has finished yet"
	self assert: p isReady.
	a noneSatisfy: [ :b | b ].
	"now let the process run and make sure all unwind blocks have finished"
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:19:55'!
test3CTerminate
	"Terminate runnable process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux3C: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is runnable and none of the unwind blocks has finished yet"
	self assert: p isReady.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:22:47'!
test3DResume
	"Resume runnable process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux3D: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is runnable and none of the unwind blocks has finished yet"
	self assert: p isReady.
	a noneSatisfy: [ :b | b ].
	"now let the process run and make sure all unwind blocks have finished"
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a second & a third & a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:20:14'!
test3DTerminate
	"Terminate runnable process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux3D: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is runnable and none of the unwind blocks has finished yet"
	self assert: p isReady.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 13:10:19'!
test4AResume
	"Resume runnable process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux4A: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is runnable and none of the unwind blocks has finished yet"
	self assert: p isReady.
	a noneSatisfy: [ :b | b ].
	"now let the process run and make sure all unwind blocks have finished"
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a third & a fourth.
	self deny: a second.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:21:21'!
test4ATerminate
	"Terminate runnable process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux4A: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is runnable and none of the unwind blocks has finished yet"
	self assert: p isReady.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a third.
	self deny: a second | a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 13:11:55'!
test4BResume
	"Resume runnable process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux4B: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is runnable and none of the unwind blocks has finished yet"
	self assert: p isReady.
	a noneSatisfy: [ :b | b ].
	"now let the process run and make sure all unwind blocks have finished"
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a second & a third & a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:21:36'!
test4BTerminate
	"Terminate runnable process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux4B: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is runnable and none of the unwind blocks has finished yet"
	self assert: p isReady.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 13:15:59'!
test4CResume
	"Resume runnable process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux4C: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is runnable and none of the unwind blocks has finished yet"
	self assert: p isReady.
	a noneSatisfy: [ :b | b ].
	"now let the process run and make sure all unwind blocks have finished"
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:21:49'!
test4CTerminate
	"Terminate runnable process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux4C: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is runnable and none of the unwind blocks has finished yet"
	self assert: p isReady.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:23:09'!
test4DResume
	"Resume runnable process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux4D: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is runnable and none of the unwind blocks has finished yet"
	self assert: p isReady.
	a noneSatisfy: [ :b | b ].
	"now let the process run and make sure all unwind blocks have finished"
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a second & a third & a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:22:02'!
test4DTerminate
	"Terminate runnable process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux4D: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is runnable and none of the unwind blocks has finished yet"
	self assert: p isReady.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 13:32:31'!
test5ATerminate
	"Terminate active process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux5A: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p suspended itself and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now let the termination continue and make sure all unwind blocks have finished"
	Processor yield.
	Processor yield.
	self assert: p isTerminated.
	self assert: a first & a third.
	self deny: a second | a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 13:32:28'!
test5BTerminate
	"Terminate active process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux5B: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p suspended itself and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now let the termination continue and make sure all unwind blocks have finished"
	Processor yield.
	Processor yield.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 13:32:25'!
test5CTerminate
	"Terminate active process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux5C: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p suspended itself and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now let the termination continue and make sure all unwind blocks have finished"
	Processor yield.
	Processor yield.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 13:32:20'!
test5DTerminate
	"Terminate active process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux5D: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p suspended itself and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now let the termination continue and make sure all unwind blocks have finished"
	Processor yield.
	Processor yield.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 13:32:14'!
test6ATerminate
	"Terminate active process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux6A: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p suspended itself and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now let the termination continue and make sure all unwind blocks have finished"
	Processor yield.
	Processor yield.
	self assert: p isTerminated.
	self assert: a first & a third.
	self deny: a second | a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 13:32:10'!
test6BTerminate
	"Terminate active process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux6B: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p suspended itself and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now let the termination continue and make sure all unwind blocks have finished"
	Processor yield.
	Processor yield.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 13:32:04'!
test6CTerminate
	"Terminate active process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux6C: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p suspended itself and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now let the termination continue and make sure all unwind blocks have finished"
	Processor yield.
	Processor yield.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 13:31:55'!
test6DTerminate
	"Terminate active process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a |
	a _ Array new: 4 withAll: false.
	p := [
			self aux6D: a
		] newProcess.
	p resume.
	Processor yield.
	"make sure p suspended itself and none of the unwind blocks has finished yet"
	self assert: p isSuspended.
	a noneSatisfy: [ :b | b ].
	"now let the termination continue and make sure all unwind blocks have finished"
	Processor yield.
	Processor yield.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 13:10:27'!
test7AResume
	"Terminate blocked process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a semaphore |
	semaphore _ Semaphore new.	
	a _ Array new: 4 withAll: false.
	p := [
			self aux7A: a semaphore: semaphore
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is blocked and none of the unwind blocks has finished yet"
	self assert: p isBlocked.
	a noneSatisfy: [ :b | b ].
	"now resume the process and make sure all unwind blocks have finished"
	semaphore signal.
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a third & a fourth.
	self deny: a second.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:24:57'!
test7ATerminate
	"Terminate blocked process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a semaphore |
	semaphore _ Semaphore new.	
	a _ Array new: 4 withAll: false.
	p := [
			self aux7A: a semaphore: semaphore
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is blocked and none of the unwind blocks has finished yet"
	self assert: p isBlocked.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a third.
	self deny: a second | a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 13:12:00'!
test7BResume
	"Terminate blocked process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a semaphore |
	semaphore _ Semaphore new.	
	a _ Array new: 4 withAll: false.
	p := [
			self aux7B: a semaphore: semaphore
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is blocked and none of the unwind blocks has finished yet"
	self assert: p isBlocked.
	a noneSatisfy: [ :b | b ].
	"now resume the process and make sure all unwind blocks have finished"
	semaphore signal.
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a second & a third & a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:25:11'!
test7BTerminate
	"Terminate blocked process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a semaphore |
	semaphore _ Semaphore new.	
	a _ Array new: 4 withAll: false.
	p := [
			self aux7B: a semaphore: semaphore
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is blocked and none of the unwind blocks has finished yet"
	self assert: p isBlocked.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 13:16:03'!
test7CResume
	"Terminate blocked process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a semaphore |
	semaphore _ Semaphore new.	
	a _ Array new: 4 withAll: false.
	p := [
			self aux7C: a semaphore: semaphore
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is blocked and none of the unwind blocks has finished yet"
	self assert: p isBlocked.
	a noneSatisfy: [ :b | b ].
	"now resume the process and make sure all unwind blocks have finished"
	semaphore signal.
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:25:26'!
test7CTerminate
	"Terminate blocked process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a semaphore |
	semaphore _ Semaphore new.	
	a _ Array new: 4 withAll: false.
	p := [
			self aux7C: a semaphore: semaphore
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is blocked and none of the unwind blocks has finished yet"
	self assert: p isBlocked.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:27:41'!
test7DResume
	"Terminate blocked process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a semaphore |
	semaphore _ Semaphore new.	
	a _ Array new: 4 withAll: false.
	p := [
			self aux7D: a semaphore: semaphore
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is blocked and none of the unwind blocks has finished yet"
	self assert: p isBlocked.
	a noneSatisfy: [ :b | b ].
	"now resume the process and make sure all unwind blocks have finished"
	semaphore signal.
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a second & a third & a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:25:40'!
test7DTerminate
	"Terminate blocked process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a semaphore |
	semaphore _ Semaphore new.	
	a _ Array new: 4 withAll: false.
	p := [
			self aux7D: a semaphore: semaphore
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is blocked and none of the unwind blocks has finished yet"
	self assert: p isBlocked.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 13:10:34'!
test8AResume
	"Terminate blocked process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a semaphore |
	semaphore _ Semaphore new.	
	a _ Array new: 4 withAll: false.
	p := [
			self aux8A: a semaphore: semaphore
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is blocked and none of the unwind blocks has finished yet"
	self assert: p isBlocked.
	a noneSatisfy: [ :b | b ].
	"now resume the process and make sure all unwind blocks have finished"
	semaphore signal.
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a third & a fourth.
	self deny: a second.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:25:59'!
test8ATerminate
	"Terminate blocked process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a semaphore |
	semaphore _ Semaphore new.	
	a _ Array new: 4 withAll: false.
	p := [
			self aux8A: a semaphore: semaphore
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is blocked and none of the unwind blocks has finished yet"
	self assert: p isBlocked.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a third.
	self deny: a second | a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 13:12:06'!
test8BResume
	"Terminate blocked process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a semaphore |
	semaphore _ Semaphore new.	
	a _ Array new: 4 withAll: false.
	p := [
			self aux8B: a semaphore: semaphore
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is blocked and none of the unwind blocks has finished yet"
	self assert: p isBlocked.
	a noneSatisfy: [ :b | b ].
	"now resume the process and make sure all unwind blocks have finished"
	semaphore signal.
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a second & a third & a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:26:12'!
test8BTerminate
	"Terminate blocked process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a semaphore |
	semaphore _ Semaphore new.	
	a _ Array new: 4 withAll: false.
	p := [
			self aux8B: a semaphore: semaphore
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is blocked and none of the unwind blocks has finished yet"
	self assert: p isBlocked.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 13:16:07'!
test8CResume
	"Terminate blocked process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a semaphore |
	semaphore _ Semaphore new.	
	a _ Array new: 4 withAll: false.
	p := [
			self aux8C: a semaphore: semaphore
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is blocked and none of the unwind blocks has finished yet"
	self assert: p isBlocked.
	a noneSatisfy: [ :b | b ].
	"now resume the process and make sure all unwind blocks have finished"
	semaphore signal.
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:26:25'!
test8CTerminate
	"Terminate blocked process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a semaphore |
	semaphore _ Semaphore new.	
	a _ Array new: 4 withAll: false.
	p := [
			self aux8C: a semaphore: semaphore
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is blocked and none of the unwind blocks has finished yet"
	self assert: p isBlocked.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:27:13'!
test8DResume
	"Terminate blocked process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a semaphore |
	semaphore _ Semaphore new.	
	a _ Array new: 4 withAll: false.
	p := [
			self aux8D: a semaphore: semaphore
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is blocked and none of the unwind blocks has finished yet"
	self assert: p isBlocked.
	a noneSatisfy: [ :b | b ].
	"now resume the process and make sure all unwind blocks have finished"
	semaphore signal.
	[ p isReady ] whileTrue: [ Processor yield ].
	self assert: p isTerminated.
	self assert: a first & a second & a third & a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'testing' stamp: 'jmv 4/29/2021 11:26:38'!
test8DTerminate
	"Terminate blocked process.
	Test all nested unwind blocks are correctly unwound; 
	all unwind blocks halfway 	through their execution should be completed."

	| p a semaphore |
	semaphore _ Semaphore new.	
	a _ Array new: 4 withAll: false.
	p := [
			self aux8D: a semaphore: semaphore
		] newProcess.
	p resume.
	Processor yield.
	"make sure p is blocked and none of the unwind blocks has finished yet"
	self assert: p isBlocked.
	a noneSatisfy: [ :b | b ].
	"now terminate the process and make sure all unwind blocks have finished"
	p terminate.
	self assert: p isTerminated.
	self assert: a first & a second & a third.
	self deny: a fourth.! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 12:52:16'!
aux1A: anArray

	[
		self aux1Ainner: anArray.
	] ensure: [
		anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 12:51:53'!
aux1Ainner: anArray


		[ ] ensure: [
			[Processor activeProcess suspend] ensure: [
				^anArray at: 1 put: true].
			anArray at: 2 put: true]
! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 12:53:12'!
aux1B: anArray

	[
		self aux1Binner: anArray
	] ensure: [
		anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 12:53:00'!
aux1Binner: anArray

	[ ] ensure: [
		[Processor activeProcess suspend] ensure: [
			anArray at: 1 put: true].
		^anArray at: 2 put: true]! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 10:11:22'!
aux1C: anArray

	[
		[ ] ensure: [
			[Processor activeProcess suspend] ensure: [
				anArray at: 1 put: true].
			anArray at: 2 put: true]
	] ensure: [
		^anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 10:11:35'!
aux1D: anArray

	[
		[ ] ensure: [
			[Processor activeProcess suspend] ensure: [
				anArray at: 1 put: true].
			anArray at: 2 put: true]
	] ensure: [
		anArray at: 3 put: true].
	^anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 12:56:05'!
aux2A: anArray

	[
		self aux2Ainner: anArray
	] ensure: [
		anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 12:55:52'!
aux2Ainner: anArray

	[ ] ensure: [
		[] ensure: [
			Processor activeProcess suspend.
			^anArray at: 1 put: true].
		anArray at: 2 put: true]! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 12:56:36'!
aux2B: anArray

	[
		self aux2Binner: anArray
	] ensure: [
		anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 12:56:22'!
aux2Binner: anArray

	[ ] ensure: [
		[] ensure: [
			Processor activeProcess suspend.
			anArray at: 1 put: true].
		^anArray at: 2 put: true]! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 10:12:36'!
aux2C: anArray

	[
		[ ] ensure: [
			[] ensure: [
				Processor activeProcess suspend.
				anArray at: 1 put: true].
			anArray at: 2 put: true]
	] ensure: [
		^anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 10:12:44'!
aux2D: anArray

	[
		[ ] ensure: [
			[] ensure: [
				Processor activeProcess suspend.
				anArray at: 1 put: true].
			anArray at: 2 put: true]
	] ensure: [
		anArray at: 3 put: true].
	^anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 12:59:48'!
aux3A: anArray

	[
		self aux3Ainner: anArray
	] ensure: [
		anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 12:59:43'!
aux3Ainner: anArray

	[ ] ensure: [
		[Processor yield] ensure: [
			^anArray at: 1 put: true].
		anArray at: 2 put: true]! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 13:00:12'!
aux3B: anArray

	[
		self aux3Binner: anArray
	] ensure: [
		anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 13:00:05'!
aux3Binner: anArray

	[ ] ensure: [
		[Processor yield] ensure: [
			anArray at: 1 put: true].
		^anArray at: 2 put: true]! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 10:14:09'!
aux3C: anArray

	[
		[ ] ensure: [
			[Processor yield] ensure: [
				anArray at: 1 put: true].
			anArray at: 2 put: true]
	] ensure: [
		^anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 10:14:17'!
aux3D: anArray

	[
		[ ] ensure: [
			[Processor yield] ensure: [
				anArray at: 1 put: true].
			anArray at: 2 put: true]
	] ensure: [
		anArray at: 3 put: true].
	^anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 13:33:30'!
aux4A: anArray

	[
		self aux4Ainner: anArray
	] ensure: [
		anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 13:33:23'!
aux4Ainner: anArray

	[ ] ensure: [
		[] ensure: [
			Processor yield.
			^anArray at: 1 put: true].
		anArray at: 2 put: true]! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 13:34:00'!
aux4B: anArray

	[
		self aux4Binner: anArray
	] ensure: [
		anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 13:33:51'!
aux4Binner: anArray

	[ ] ensure: [
		[] ensure: [
			Processor yield.
			anArray at: 1 put: true].
		^anArray at: 2 put: true]! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 10:14:54'!
aux4C: anArray

	[
		[ ] ensure: [
			[] ensure: [
				Processor yield.
				anArray at: 1 put: true].
			anArray at: 2 put: true]
	] ensure: [
		^anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 10:15:03'!
aux4D: anArray

	[
		[ ] ensure: [
			[] ensure: [
				Processor yield.
				anArray at: 1 put: true].
			anArray at: 2 put: true]
	] ensure: [
		anArray at: 3 put: true].
	^anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 13:34:41'!
aux5A: anArray

	[
		self aux5Ainner: anArray
	] ensure: [
		anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 13:34:35'!
aux5Ainner: anArray

	[ ] ensure: [
		[Processor activeProcess terminate] ensure: [
			^anArray at: 1 put: true].
		anArray at: 2 put: true]! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 13:35:04'!
aux5B: anArray

	[
		self aux5Binner: anArray
	] ensure: [
		anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 13:34:57'!
aux5Binner: anArray

	[ ] ensure: [
		[Processor activeProcess terminate] ensure: [
			anArray at: 1 put: true].
		^anArray at: 2 put: true]! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 10:16:05'!
aux5C: anArray

	[
		[ ] ensure: [
			[Processor activeProcess terminate] ensure: [
				anArray at: 1 put: true].
			anArray at: 2 put: true]
	] ensure: [
		^anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 10:16:13'!
aux5D: anArray

	[
		[ ] ensure: [
			[Processor activeProcess terminate] ensure: [
				anArray at: 1 put: true].
			anArray at: 2 put: true]
	] ensure: [
		anArray at: 3 put: true].
	^anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 13:35:35'!
aux6A: anArray

	[
		self aux6Ainner: anArray
	] ensure: [
		anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 13:35:29'!
aux6Ainner: anArray

	[ ] ensure: [
		[] ensure: [
			Processor activeProcess terminate.
			^anArray at: 1 put: true].
		anArray at: 2 put: true]! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 13:35:58'!
aux6B: anArray

	[
		self aux6Binner: anArray
	] ensure: [
		anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 13:35:52'!
aux6Binner: anArray

	[ ] ensure: [
		[] ensure: [
			Processor activeProcess terminate.
			anArray at: 1 put: true].
		^anArray at: 2 put: true]! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 10:16:48'!
aux6C: anArray

	[
		[ ] ensure: [
			[] ensure: [
				Processor activeProcess terminate.
				anArray at: 1 put: true].
			anArray at: 2 put: true]
	] ensure: [
		^anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 10:16:56'!
aux6D: anArray

	[
		[ ] ensure: [
			[] ensure: [
				Processor activeProcess terminate.
				anArray at: 1 put: true].
			anArray at: 2 put: true]
	] ensure: [
		anArray at: 3 put: true].
	^anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 13:37:13'!
aux7A: anArray semaphore: semaphore

	[
		self aux7Ainner: anArray semaphore: semaphore
	] ensure: [
		anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 13:37:07'!
aux7Ainner: anArray semaphore: semaphore

	[ ] ensure: [
		[semaphore wait] ensure: [
			^anArray at: 1 put: true].
		anArray at: 2 put: true]! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 14:23:17'!
aux7B: anArray semaphore: semaphore

	[
		self aux7Binner: anArray semaphore: semaphore
	] ensure: [
		anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 14:23:09'!
aux7Binner: anArray semaphore: semaphore

	[ ] ensure: [
		[semaphore wait] ensure: [
			anArray at: 1 put: true].
		^anArray at: 2 put: true]! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 11:00:23'!
aux7C: anArray semaphore: semaphore

	[
		[ ] ensure: [
			[semaphore wait] ensure: [
				anArray at: 1 put: true].
			anArray at: 2 put: true]
	] ensure: [
		^anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 11:00:28'!
aux7D: anArray semaphore: semaphore

	[
		[ ] ensure: [
			[semaphore wait] ensure: [
				anArray at: 1 put: true].
			anArray at: 2 put: true]
	] ensure: [
		anArray at: 3 put: true].
	^anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 14:24:12'!
aux8A: anArray semaphore: semaphore

	[
		self aux8Ainner: anArray semaphore: semaphore
	] ensure: [
		anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 14:24:06'!
aux8Ainner: anArray semaphore: semaphore

	[ ] ensure: [
		[] ensure: [
			semaphore wait.
			^anArray at: 1 put: true].
		anArray at: 2 put: true]! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 14:24:33'!
aux8B: anArray semaphore: semaphore

	[
		self aux8Binner: anArray semaphore: semaphore
	] ensure: [
		anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 14:24:28'!
aux8Binner: anArray semaphore: semaphore

	[ ] ensure: [
		[] ensure: [
			semaphore wait.
			anArray at: 1 put: true].
		^anArray at: 2 put: true]! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 11:00:50'!
aux8C: anArray semaphore: semaphore

	[
		[ ] ensure: [
			[] ensure: [
				semaphore wait.
				anArray at: 1 put: true].
			anArray at: 2 put: true]
	] ensure: [
		^anArray at: 3 put: true].
	anArray at: 4 put: true! !

!ProcessTerminateUnwindNonLocalReturn methodsFor: 'aux' stamp: 'jmv 4/29/2021 11:00:54'!
aux8D: anArray semaphore: semaphore

	[
		[ ] ensure: [
			[] ensure: [
				semaphore wait.
				anArray at: 1 put: true].
			anArray at: 2 put: true]
	] ensure: [
		anArray at: 3 put: true].
	^anArray at: 4 put: true! !

!methodRemoval: ProcessTerminateBug #testResumptionDuringNestedUnwind8 stamp: 'jmv 4/29/2021 15:00:56'!
ProcessTerminateBug removeSelector: #testResumptionDuringNestedUnwind8!
!methodRemoval: ProcessTerminateBug #testResumptionDuringNestedUnwind4 stamp: 'jmv 4/29/2021 15:00:56'!
ProcessTerminateBug removeSelector: #testResumptionDuringNestedUnwind4!
!methodRemoval: ProcessTerminateBug #testResumptionDuringNestedUnwind3 stamp: 'jmv 4/29/2021 15:00:56'!
ProcessTerminateBug removeSelector: #testResumptionDuringNestedUnwind3!
!methodRemoval: ProcessTerminateBug #testResumptionDuringNestedUnwind2 stamp: 'jmv 4/29/2021 15:00:56'!
ProcessTerminateBug removeSelector: #testResumptionDuringNestedUnwind2!
!methodRemoval: ProcessTerminateBug #testResumptionDuringNestedUnwind1 stamp: 'jmv 4/29/2021 15:00:56'!
ProcessTerminateBug removeSelector: #testResumptionDuringNestedUnwind1!
!methodRemoval: ProcessTerminateBug #testResumptionDuringNestedUnwind7 stamp: 'jmv 4/29/2021 15:00:56'!
ProcessTerminateBug removeSelector: #testResumptionDuringNestedUnwind7!
